<template>
  <Line :data="preparedData" :options="options" />
</template>

<script>
import { Line } from 'vue-chartjs'
import {
  Chart as ChartJS,
  CategoryScale,
  LinearScale,
  PointElement,
  LineElement,
  Title,
  Tooltip,
  // Legend,
  Filler
} from 'chart.js';

ChartJS.register(
  CategoryScale,
  LinearScale,
  PointElement,
  LineElement,
  Title,
  Tooltip,
  // Legend,
  Filler
);

export default {
  name : "LineChart",
  components: { Line },
  props: {
    // eslint-disable-next-line vue/require-default-prop
    chartData: {
      type: [Array, Object],
      required: true
    },
    chartLabels: {
      type: Array,
      required: true
    },
    title: {
      type: String,
      default: '[No title]',
      required: false
    },
    chartBackgroundColors: {
      type: Array
    }
  },
  data () {
    return {
      preparedData: {
        labels: this.chartLabels,
        datasets: [
          {
            label: this.title,
            backgroundColor: this.chartBackgroundColors[0],
            data: this.chartData,
            fill: true,
            pointBackgroundColor: 'rgba(0,0,0,0.2)',
            tension: 0.2
          }
        ]
      },
      options: {
        title: {
          display: false,
          text: this.title
        },
        scales: {
          yAxes: [{
            ticks: {
              beginAtZero: true,
              stepSize: parseInt(this.$env.SCORING_STEP_SIZE),
              max: parseInt(this.$env.SCORING_MAX_POINTS)
            },
            gridLines: {
              display: true
            }
          }],
          xAxes: [{
            gridLines: {
              display: true
            }
          }]
        },
        responsive: true,
        plugins: {
          legend: {
            display: false
          },
          datalabels: {
            display: false,
          },
          tooltip: {
            // Toolbar an/aus
            enabled: true
          }
        }
      }
    }
  }
};
</script>
